<?php
/*	manager : standard theme manager based on v1.6
	name : theme manager
	author: team1/3
*/

	global $html,$params,$database,$config,$ut,$plugin_ar;

	if (!isset($config)) { die(); }
	
	if (!check_rights('admin')) {
		exit_proc(505, 'Access denied');
	}

	$params['manager'] = true;
	//$params['template'] = 'admin.tpl';
	draw();
	$params['rendering'] = false;

function draw()
{
	global $html,$params,$database,$ut;
	
	$p_page = $params['page']['id'];

	if (isset($_GET['mode']) && $_GET['mode'] == 'edit') {
		provide_edit_module();
		snippet_breadcrumb($p_page, 'Page Edit');
		$buff = page_edit_renderer($params['page']);
		$html['article'][] = frame_renderer($buff);
		return;
	}

	$buff ='';
	$buff .= basic_renderer($p_page);
	$html['article'][] = $buff;

	$tab_ar=array();
	$tab_ar[] = array('name'=>'Global Menu',	'proc'=>'link_menu_tab', 'arg'=>'global_menu' );
	$tab_ar[] = array('name'=>'Main Visual',	'proc'=>'main_visual_tab' );
	$tab_ar[] = array('name'=>'Background',		'proc'=>'background_tab' );
	$tab_ar[] = array('name'=>'Additional css',	'proc'=>'additional_css_tab' );
	$tab_ar[] = array('name'=>'System Menu',	'proc'=>'system_menu_tab' );

	$tab = 0;
	if (isset($_SESSION['tab'])) {
		$tab = (int)$_SESSION['tab'];
	}


$tmp = <<<EOT
	<script>
		\$(function(){
			ot.set_tab($tab);
		});
		ot.set_tab = function (tab) {
			\$('.tab_x').hide();
			\$('.tab_x'+tab).show();
			\$('.tab_h').removeClass('active');
			\$('.tab_h'+tab).show();
			\$('.tab_h'+tab).addClass('active');
			ot.ajax({
				type: "POST"
				, url: '{$params['request_name']}'
				, data: "ajax=set_tab&data="+tab
				, dataType:'json'
				, success: function(data){
				}
			});
		};
	</script>
EOT;

	$html['meta'][] = $tmp;
	if (isset($_POST['ajax']) && $_POST['ajax'] == 'set_tab')  {
		$r = array();
		if (isset($_POST['data'])) { $r['result'] = $_SESSION['tab'] = (int)$_POST['data']; }
		echo(json_encode($r));
		exit();
	}

$buff = <<<EOT
	<div >
		<div class='onethird-tab'>
			<ul class='tab-head clearfix'>
EOT;
			$i=0;
			for($i=0;$i<count($tab_ar);++$i) {
				$v = $tab_ar[$i];
				$buff.=("<li class='tab_h$i tab_h '><a href='javascript:void(ot.set_tab($i))' >{$v['name']}</a></li>");
			}
$buff.= <<<EOT
			</ul>

			<div class='tab-body'>
EOT;
			for($i=0;$i<count($tab_ar);++$i) {
				if ( function_exists($tab_ar[$i]['proc'])) {
$buff.= <<<EOT
					<div class='tab_x$i tab_x' style='display:none'>
EOT;
					$arg = false;
					if (isset($tab_ar[$i]['arg'])) {
						$arg = $tab_ar[$i]['arg'];
					}
					$buff .= $tab_ar[$i]['proc']($arg);
$buff.= <<<EOT
					</div>
EOT;
				}
			}
$buff.= <<<EOT
			</div>
		</div> 
	</div> 
EOT;

	$html['article'][] = frame_renderer($buff);
}

function link_menu_tab($tag_name)
{
	global $html,$params,$database,$ut,$config,$p_circle;

	$top_page = $params['circle']['meta']['top_page'];
	$meta = get_theme_metadata();

	if (isset($_POST['ajax']) && $_POST['ajax'] == 'theme_links_save')  {
		$r = array();
		$r['result'] = false;
		$r['tag'] = $tag_name;
		if (isset($_POST['data'])) { $r['data'] = sanitize_str($_POST['data']); }
		$m = array();
		$c = '';
		$dx = explode("\n",$r['data']);
		reset($dx);
		$fst = 1;
		while (($v1 = current($dx)) !== false) {
			$v2 = next($dx);
			$v3 = next($dx);
			next($dx);
			if ($v1) {
				$m[] = array('text'=>$v1, 'link'=>$v2, 'mobi'=>$v3 || $fst);
				$fst = false;
			}
		}
		$ar = array();
		$ar['id'] = $top_page;
		$ar['meta'] = $meta;
		$ar['meta']['theme'][$r['tag']] = $m;
		$r['nopage'] = '';
		foreach ($m as $v) {
			if (!is_numeric($v['link']) && ctype_alnum($v['link'])) {
				if (!isset($params['circle']['meta']['alias'][$v['link']])) {
					if ($r['nopage']) { $r['nopage'] .=','; }
					$r['nopage'] .= $v['text'];
				}
			}
		}
		$r['result'] = mod_data_items($ar);
		echo(json_encode($r));
		exit();
	}
	if (isset($_POST['ajax']) && $_POST['ajax'] == 'theme_links_create')  {
		$r = array();
		$r['result'] = false;
		$meta = get_theme_metadata();
		$ar = array();
		$m = $meta['theme'][$tag_name];
		$ok = true;
		foreach ($m as $v) {
			if (!is_numeric($v['link']) && ctype_alnum($v['link'])) {
				if (!isset($params['circle']['meta']['alias'][$v['link']])) {
					$rx = array();
					$rx['mode'] = 1;
					$rx['type'] = 1;
					$rx['title'] = $v['text'];
					$ok |= create_page( $rx );
					$params['circle']['meta']['alias'][$v['link']] = $rx['id'];
					if ($ok && !$database->sql_update("update ".DBX."circles set metadata=? where id=?", serialize64($params['circle']['meta']), $p_circle)) {
						$ok = false;
					}
					if (!$ok) { break; }
				}
			}
			$r['result'] = $ok;
		}
		echo(json_encode($r));
		exit();
	}

$tmp = <<<EOT
	<script>
		\$(function(){
			\$(document).on('click','.theme_links .del',function(){
				\$(this).parent().remove();
			});
			\$(document).on('click','.theme_links .up',function(){
				var t = \$(this).parent();
				var n = t.prev();
				if (n) { n.before(t); }
			});
			\$(document).on('click','.theme_links .dn',function(){
				var t = \$(this).parent();
				var n = t.next();
				if (n) { n.after(t); }
			});
EOT;
			if (isset($meta['theme'][$tag_name])) {
				$tmp .= "var data=".json_encode($meta['theme'][$tag_name]).";";;
			} else {
				$tmp .= "var data=[];";
			}
$tmp .= <<<EOT
			for (var i=0; i < data.length; ++i) {
				ot.theme_links_add_item(data[i]);
			}
		});
		ot.theme_links_add_item = function (tag) {
			var a = "<div><input type='text' value='"+tag['text']+"' style='width:150px;' /> ";
			a += "<input type='text' value='"+tag['link']+"' style='width:200px;' />";
			a += "<label><input type='checkbox' ";
			if (tag['mobi']) {
				a += " checked ";
			}
			a += " />mobile</label>";
			a += " {$ut->icon('up'," class='up' style='width:25px' ")}";
			a += " {$ut->icon('dn'," class='dn' style='width:25px' ")}";
			a += " {$ut->icon('delete'," class='del' style='width:25px' ")}";
			a += "</div>";
			\$('.theme_links').append(a);
		};
		ot.theme_links_save = function () {
			var d = '';
			\$('.theme_links input').each(function(){
				if (this.type == 'checkbox') {
					if (this.checked) { d+='1'; }
					d += "\\n";
				} else {
					d += \$(this).val()+"\\n";
				}
			});
			ot.ajax({
				type: "POST"
				, url: '{$params['request_name']}'
				, data: "ajax=theme_links_save&data="+encodeURIComponent(d)
				, dataType:'json'
				, success: function(data){
					if ( data && data['result'] ) {
						if (data['nopage']) {
							if (confirm('Page '+data['nopage']+' is not found, make this page?')) {
							var a = 
							ot.ajax({
								type: "POST"
								, url: '{$params['request_name']}'
								, data: "ajax=theme_links_create&tag="+\$('.theme_links').attr('data-tag')
								, dataType:'json'
								, success: function(data){
									if ( data && data['result'] ) {
										location.reload(true);
									}
								}
							});
							}
						} else {
							location.reload(true);
						}
					}
				}
			});
		};
	</script>
EOT;

	$html['meta'][] = $tmp;

$tmp = <<<EOT
	<div class='onethird-setting'>
		<div class='theme_links' data-tag='$tag_name'  >
		</div>
		<div class='actions' >
			<input type='button' class='onethird-button' value='Update' onclick='ot.theme_links_save(1)' />
			<input type='button' class='onethird-button' value='Add' onclick="ot.theme_links_add_item({link:'',text:''})" />
		</div>
	</div>
EOT;
	return $tmp;
}

function main_visual_tab()
{
	global $params,$html,$ut;
	
	$meta = get_theme_metadata();
	$img = img_proc(array('page'=>'top','group'=>'.img', 'name'=>'main_visual','style'=>'width:120%',"first_mess:Add image"));

	snippet_colorpicker($params['page']);

	$c = '#000000';
	if (!empty($meta['flexcolor']['main_font_color'])) {
		$c = $meta['flexcolor']['main_font_color'];
	}

$html['meta'][] = <<<EOT
	<script>
		\$(function(){
			\$('#main_visual_preview,#main_visual_preview h1').css('color',"$c");
			emm();
			\$('.emm').click(function(){
				emm(\$(this).val());
			});
		});
		function emm(o) {
			if (o == 'tablet') {
				\$('#main_visual_img').width(491).height(258);
				\$('#main_visual_img img:first').css('width','100%');
				\$('#main_visual_txt').width(435);
				\$('#main_visual_txt').css({
					'font-size':'15px'
					,'left':'3%'
					,'top':'3%'
				});
				\$('#main_visual_txt a').css({
					'font-size':'11px'
				});
			} else {
				\$('#main_visual_img').width(330).height(230);
				\$('#main_visual_img img:first').css('width','120%');
				\$('#main_visual_txt').width(300);
				\$('#main_visual_txt').css({
					'font-size':'15px'
					,'left':'2%'
					,'top':'1%'
				});
				\$('#main_visual_txt a').css({
					'font-size':'15px'
				});
				\$('#main_visual_txt h1').css({
					'font-size':'28px'
				});
			}
		}
	</script>
EOT;

	$out = '';
	if (function_exists('get_catch_html')) {
		$out = get_catch_html(true);
	}

	if (empty($meta['flexfile']['main_visual'])) {
$buff = <<<EOT
		<p>$img</p>
EOT;
	} else {
$buff = <<<EOT
		<div style='margin:10px 0'>
			<input type='button' value='text color' onclick="ot.open_color_dialog({page:'top',name:'main_font_color', selector:'#main_visual_preview,#main_visual_preview h1', value:'{$c}'})" class='onethird-button' />
			<input type='button' value='main image' onclick="ot.inpage_img({page:{$ut->get_home_id()} ,group:'.img'  ,name:'main_visual',resize:'auto,1200/800/1,0/0'})" class='onethird-button' />
			<input type='button' value='reload' onclick='location.reload(true);' class='onethird-button' />
		</div>
		<p>
			<label><input type='radio' value='phone' name='emm' class='emm' checked /> phone</label>
			<label><input type='radio' value='tablet' name='emm' class='emm' /> tablet</label>
		</p>
		<div id='main_visual_preview' style='position: relative;color:$c;margin-bottom:100px'>
			<div id='main_visual_img' style='overflow: hidden;'>
				$img
			</div>
			<div id='main_visual_txt' style='position: absolute;top: 2%;left: 3%;'>
				$out
			</div>
		</div>
EOT;
	}
	expand_buff($buff);
	return $buff;
}

function background_tab()
{
	global $params,$html,$ut;
	
	snippet_colorpicker($params['page']);

	$meta = get_theme_metadata();

	$main_bk_color = '';
	if (!empty($meta['flexcolor']['main_bk_color'])) {
		$main_bk_color = $meta['flexcolor']['main_bk_color'];
	}
	$main_ft_color = '';
	if (!empty($meta['flexcolor']['main_ft_color'])) {
		$main_ft_color = $meta['flexcolor']['main_ft_color'];
	}
	$main_ft_bk_color = '';
	if (!empty($meta['flexcolor']['main_ft_bk_color'])) {
		$main_ft_bk_color = $meta['flexcolor']['main_ft_bk_color'];
	}

$html['meta'][] = <<<EOT
	<script>
		function color_dialog_onchange(z) {
			var a = z.substr(0,7);
			var b = \$('span[data-name=main_bk_percent] input').val();
			\$('.jumbotron .overlay').css('background-image','linear-gradient('+a+'00 0%, '+a+'00 '+b+'%, '+z+' 100%');
		}
	</script>
EOT;

	$plugin = 'plugin_proc';
$buff = <<<EOT
	<div style='margin:10px 10px' >
		<p >
			<input type='button' value='background color' onclick="ot.open_color_dialog({page:'top',name:'main_bk_color', selector:'body', value:'$main_bk_color',type:'background',onchange:color_dialog_onchange})" class='onethird-button' />
		</p>
		<p>
		<p class='ix' >overlay percent &nbsp {$plugin('embed','text','page:top','name:main_bk_percent','width:50px','style;margin-right:10px;')} 0(max) ... 100(min) default 70% </p>
		<p >
			<input type='button' value='footer background color' onclick="ot.open_color_dialog({page:'top',name:'main_ft_bk_color', selector:'.footer', value:'$main_ft_bk_color',type:'background'})" class='onethird-button' />
		</p>
		<p >
			<input type='button' value='footer text color' onclick="ot.open_color_dialog({page:'top',name:'main_ft_color', selector:'.footer', value:'$main_ft_color'})" class='onethird-button' />
		</p>
		<p>
			<input type='button' value='reload' onclick='location.reload(true);' class='onethird-button' />
		</p>
	</div>
EOT;

	return $buff;
}

function additional_css_tab()
{
	global $params,$html,$ut;

$buff = <<<EOT
	<input type='button' class='onethird-button ' value='Edit additional css' onclick="ot.inpage_edit({'page':'top','mode':'1','name':'main_addcss', 'height':'300px'})" />
EOT;


	return $buff;
}

function system_menu_tab()
{
	global $p_circle,$params,$html,$database;
	
	if ( isset($_POST['ajax']) && $_POST['ajax'] == 'del_menus' ) {
		$r = array();
		$r['result'] = false;
		$t = sanitize_str($_POST['data']);
		$m = get_circle_meta('system_menus');
		unset($m[$t]);
		$r['result'] = set_circle_meta('system_menus',$m);
		echo( json_encode($r) );
		exit();
	}
	if ( isset($_POST['ajax']) && $_POST['ajax'] == 'add_menus' ) {
		$r = array();
		$m = get_circle_meta('system_menus');
		$k = "t".sprintf('%05d',mt_rand(0,1000));
		if (isset($m['$k'])) {
			$r['result'] = false;
			echo( json_encode($r) );
			exit();
		}
		$r['title'] = 'new menu '.$k;
		$r['rights'] = '';
		$m[$k] = array('title'=>$r['title'], 'url'=>'', 'rights'=>$r['rights']);
		$r['result'] = set_circle_meta('system_menus',$m);
		$r['id'] = $k;
		echo( json_encode($r) );
		exit();
	}
	
	if ( isset($_POST['ajax']) && $_POST['ajax'] == 'mod_menus' ) {
		$r = array();
		$m = get_circle_meta('system_menus');
		$k = sanitize_str($_POST['id']);
		$r['title'] = sanitize_str($_POST['title']);
		$r['url'] = sanitize_str($_POST['url']);
		$r['rights'] = sanitize_str($_POST['rights']);
		$r['opt'] = sanitize_str($_POST['opt']);
		$r['id'] = $k;
		$m[$k] = array('title'=>$r['title'], 'url'=>$r['url'], 'rights'=>$r['rights'], 'opt'=>$r['opt']);
		$r['result'] = set_circle_meta('system_menus',$m);
		$r['m'] = $m;
		echo( json_encode($r) );
		exit();
	}

$html['meta'][] = <<<EOT
	<script>
		sel_menu_item();
		function del_menus() {
			var a = \$('#p_menus option:selected');
			if (a.length) {
				ot.ajax({
					type: "POST"
					, url: '{$params['request_name']}'
					, data: "ajax=del_menus&data="+a.val()
					, dataType:'json'
					, success: function(data){
						if ( data && data['result'] ) {
							\$('#p_menus option:selected').remove();
							sel_menu_item();
						}
					}
				});
			}
		}

		function add_menus() {
			ot.ajax({
				type: "POST"
				, url: '{$params['request_name']}'
				, data: "ajax=add_menus"
				, dataType:'json'
				, success: function(data){
					if ( data && data['result'] ) {
						\$('#p_menus')
						.append("<option value='"+data['id']+"' data-url='' data-rights='"+data['rights']+"'>"+data['title']+"</option>")
						.val(data['id']);
						sel_menu_item();
					}
				}
			});
		}

		function mod_menus() {
			var t = \$('#menus_title').val();
			var r = \$('#menus_rights').val();
			var u = \$('#menus_url').val();
			var id = \$('#menus_id').val();
			var opt = \$('#menus_opt').val();
			ot.ajax({
				type: "POST"
				, url: '{$params['request_name']}'
				, data: "ajax=mod_menus&title="+encodeURIComponent(t)+"&url="+encodeURIComponent(u)+"&rights="+encodeURIComponent(r)+"&id="+encodeURIComponent(id)+"&opt="+encodeURIComponent(opt)
				, dataType:'json'
				, success: function(data){
					if ( data && data['result'] ) {
						var o = \$('#p_menus option:selected');
						o.val(data['id']);
						o.text(data['title']);
						o.attr('data-url',data['url']);
						o.attr('data-rights',data['rights']);
						o.attr('data-opt',data['opt']);
					}
				}
			});
		}

		function sel_menu_item() {
			var o = \$('#p_menus option:selected');
			var i = o.val();
			var t = o.text();
			var r = o.attr('data-rights');
			var u = o.attr('data-url');
			var op = o.attr('data-opt');
			if (o.length) {
				\$('#menus_id').val(i);
				\$('#menus_title').val(t);
				\$('#menus_rights').val(r);
				\$('#menus_opt').val(op);
				\$('#menus_url').val(decodeURIComponent(u));
				\$('#submit_update,#submit_del').prop('disabled',false);
			} else {
				\$('#submit_update,#submit_del').prop('disabled',true);
			}
		}

	</script>
EOT;
	
	$m = get_circle_meta('system_menus');
	$buff = '';

$buff.= <<<EOT
	<div class='onethird-setting'>
		<table>
			<tr>
				<td>System menu</td>
				<td>
					<select id='p_menus' name='p_menus' size=4 onclick='sel_menu_item()' onselect='sel_menu_item()' >
EOT;
					if (!empty($m)) {
						foreach ($m as $k=>$v) {
							if (!is_array($v)) { continue; }
							$t = $v['title'];
							$u = urlencode($v['url']);
							$r = $v['rights'];
							$o = (!empty($v['opt']))? $v['opt']:'';
$buff.= <<<EOT
							<option value='{$k}' data-url='{$u}' data-rights='{$r}' data-opt='{$o}'>$t</option>
EOT;
						}
					}
$buff.= <<<EOT
					</select> 
					<p >
						id <input type='text' id='menus_id' style='width:100px' readonly />
					</p >
					<p >
						title <input type='text' id='menus_title' style='width:200px' />
					</p >
					<p >
						rights 
						<select id='menus_rights' style='width:100px' />
							<option value=''>all user</option>
							<option value='edit'>edit</option>
							<option value='admin'>admin</option>
						</select>
					</p >
					<p >
						opt <input type='text' id='menus_opt' style='width:200px'  />
					</p>
					<p >
						url, page mumber or page alias
						<input type='text' id='menus_url' />
					</p>
					<p>
						<input type='button' id='submit_update' value='Update' onclick='mod_menus()' class='onethird-button mini' />
						<input type='button' id='submit_del' value='Remove' onclick='del_menus()' class='onethird-button mini' />
						<input type='button' id='submit_add' value='Add' onclick='add_menus()' class='onethird-button mini' />
					</p>
				</td>
			</tr>
		</table>
	</div>
EOT;
	return $buff;

}
?>